      DOUBLE PRECISION FUNCTION dlog1p(x)
C     (dlog1p)
C     Return dlog(1 + x), taking care to avoid subtraction loss.
C
C     This version uses the NAG library for the computation.
C     (24-Jun-2002)
      DOUBLE PRECISION x, y
      DOUBLE PRECISION s01baf
      INTEGER ifail
      ifail = 1
      y = s01baf(x, ifail)
      IF (ifail .NE. 0) THEN
          IF (x .EQ. -1.0D+00) THEN
              y = 0.0d+00
              y = 1.0d+00 / y
          ELSE
              y = 0.0d+00
              y = y / y
          END IF
      END IF
      dlog1p = y
      END
